Index: LMDZ6/trunk/libf/phylmdiso/pbl_surface_mod.F90
===================================================================
--- LMDZ6/trunk/libf/phylmdiso/pbl_surface_mod.F90	(revision 3939)
+++ LMDZ6/trunk/libf/phylmdiso/pbl_surface_mod.F90	(revision 3940)
@@ -2119,8 +2271,16 @@
 
           ! Calculate the temperature et relative humidity at 2m and the wind at 10m 
+          IF (iflag_new_t2mq2m==1) THEN
+           CALL stdlevvarn(klon, knon, is_ter, zxli, &
+               yu(:,1), yv(:,1), yt(:,1), yq(:,1), zgeo1, &
+               yts, yqsurf, yz0m, yz0h, ypaprs(:,1), ypplay(:,1), &
+               yt2m, yq2m, yt10m, yq10m, yu10m, yustar, &
+               yn2mout(:, nsrf, :))
+          ELSE 
           CALL stdlevvar(klon, knon, is_ter, zxli, &
                yu(:,1), yv(:,1), yt(:,1), yq(:,1), zgeo1, &
                yts, yqsurf, yz0m, yz0h, ypaprs(:,1), ypplay(:,1), &
                yt2m, yq2m, yt10m, yq10m, yu10m, yustar)
+          ENDIF
           
        ENDIF
@@ -2211,5 +2371,5 @@
           CALL surf_landice(itap, dtime, knon, ni, &
                rlon, rlat, debut, lafin, &
-               yrmu0, ylwdown, yalb, ypphi(:,1), &
+               yrmu0, ylwdown, yalb, zgeo1, &
                ysolsw, ysollw, yts, ypplay(:,1), &
 !!jyg               ycdragh, ycdragm, yrain_f, ysnow_f, yt(:,1), yq(:,1),&
@@ -2221,5 +2381,5 @@
                ytsoil, yz0m, yz0h, SFRWL, yalb_dir_new, yalb_dif_new, yevap,yfluxsens,yfluxlat, &
                ytsurf_new, y_dflux_t, y_dflux_q, &
-               yzsig, ycldt, &
+               yzmea, yzsig, ycldt, &
                ysnowhgt, yqsnow, ytoice, ysissnow, &
                yalb3_new, yrunoff, &
@@ -2284,5 +2444,7 @@
                yz0m, yz0h, SFRWL,yalb_dir_new, yalb_dif_new, yevap, yfluxsens,yfluxlat,&
                ytsurf_new, y_dflux_t, y_dflux_q, slab_wfbils, &
-               y_flux_u1, y_flux_v1 &
+               y_flux_u1, y_flux_v1, ydelta_sst(:knon), ydelta_sal(:knon), &
+               yds_ns(:knon), ydt_ns(:knon), ydter(:knon), ydser(:knon), &
+               ytkt(:knon), ytks(:knon), ytaur(:knon), ysss &
 #ifdef ISO
          &      ,yxtrain_f, yxtsnow_f,yxt1,Roce, &
@@ -2392,7 +2554,15 @@
 !
 !****************************************************************************************
-
-!!!
-!!! jyg le 10/04/2013
+!!
+!!!
+!!! jyg le 10/04/2013 et EV 10/2020
+
+        IF (ok_forc_tsurf) THEN
+            DO j=1,knon
+                ytsurf_new(j)=tg
+                y_d_ts(j) = ytsurf_new(j) - yts(j) 
+            ENDDO
+        ENDIF ! ok_forc_tsurf
+
 !!!
         IF (ok_flux_surf) THEN
@@ -2429,35 +2599,105 @@
 #endif
           ENDDO
-        ENDIF
-
-       IF (prt_level >=10) THEN
-        DO j=1,knon
-         print*,'y_flux_t1,yfluxlat,wakes' &
- &             ,  y_flux_t1(j), yfluxlat(j), ywake_s(j)
-         print*,'beta,ytsurf_new', ybeta(j), ytsurf_new(j)
-         print*,'inertia,facteur,cstar', inertia, facteur,wake_cstar(j)
-        ENDDO
-       ENDIF
-
-!!! jyg le 07/02/2012 puis le 10/04/2013
-!!       IF (iflag_split .eq.1) THEN
-!!!!!
-!!!jyg<
-!!         CALL wx_pbl_split_no_dts(knon, ywake_s, &
-!!                                AcoefH_x, AcoefH_w, &
-!!                                AcoefQ_x, AcoefQ_w, &
-!!                                AcoefU_x, AcoefU_w, &
-!!                                AcoefV_x, AcoefV_w, &
-!!                                y_flux_t1, y_flux_q1, y_flux_u1, y_flux_v1, &
-!!                                y_flux_t1_x, y_flux_t1_w, &
-!!                                y_flux_q1_x, y_flux_q1_w, &
-!!                                y_flux_u1_x, y_flux_u1_w, &
-!!                                y_flux_v1_x, y_flux_v1_w, &
-!!                                yfluxlat_x, yfluxlat_w &
-!!                                )
-!!       ELSE IF (iflag_split .ge. 2) THEN
+        ENDIF ! (ok_flux_surf)
+!
+! ------------------------------------------------------------------------------
+! 12a)  Splitting
+! ------------------------------------------------------------------------------
+
        IF (iflag_split .GE. 1) THEN
-         CALL wx_pbl0_split(knon, dtime, ywake_s, &
+#ifdef ISO
+        call abort_gcm('pbl_surface_mod 2607','isos pas encore dans iflag_split=1',1)
+#endif
+!
+         IF (nsrf .ne. is_oce) THEN
+!
+!         Compute potential evaporation and aridity factor  (jyg, 20200328)
+          ybeta_prev(:) = ybeta(:)
+             DO j = 1, knon
+               yqa(j) = AcoefQ(j) - BcoefQ(j)*yevap(j)*dtime
+             ENDDO
+!
+          CALL wx_evappot(knon, yqa, yTsurf_new, yevap_pot)
+!
+          ybeta(1:knon) = min(yevap(1:knon)/yevap_pot(1:knon), 1.)
+          
+          IF (prt_level >=10) THEN
+           DO j=1,knon
+            print*,'y_flux_t1,yfluxlat,wakes' &
+ &                ,  y_flux_t1(j), yfluxlat(j), ywake_s(j)
+            print*,'beta_prev, beta, ytsurf_new', ybeta_prev(j), ybeta(j), ytsurf_new(j)
+            print*,'inertia,facteur,cstar', inertia, facteur,wake_cstar(j)
+           ENDDO
+          ENDIF  ! (prt_level >=10)
+!
+! Second call to wx_pbl0_merge and wx_pbl_dts_merge in order to take into account 
+! the update of the aridity coeficient beta.
+!
+        CALL wx_pbl_prelim_beta(knon, dtime, ywake_s, ybeta,  &
+                        BcoefQ_x, BcoefQ_w  &
+                        )
+        CALL wx_pbl0_merge(knon, ypplay, ypaprs,  &
+                          ywake_s, ydTs0, ydqs0, &
+                          yt_x, yt_w, yq_x, yq_w, &
+                          yu_x, yu_w, yv_x, yv_w, &
+                          ycdragh_x, ycdragh_w, ycdragq_x, ycdragq_w, &
+                          ycdragm_x, ycdragm_w, &
+                          AcoefH_x, AcoefH_w, AcoefQ_x, AcoefQ_w, &
+                          AcoefU_x, AcoefU_w, AcoefV_x, AcoefV_w, &
+                          BcoefH_x, BcoefH_w, BcoefQ_x, BcoefQ_w, &
+                          BcoefU_x, BcoefU_w, BcoefV_x, BcoefV_w, &
+                          AcoefH_0, AcoefQ_0, AcoefU, AcoefV, &
+                          BcoefH_0, BcoefQ_0, BcoefU, BcoefV, &
+                          ycdragh, ycdragq, ycdragm, &
+                          yt1, yq1, yu1, yv1 &
+                          )
+          IF (iflag_split .eq. 2) THEN
+            CALL wx_pbl_dts_merge(knon, dtime, ypplay, ypaprs, &
+                            ywake_s, ybeta, ywake_cstar, ywake_dens, &
+                            AcoefH_x, AcoefH_w, &
+                            BcoefH_x, BcoefH_w, &
+                            AcoefH_0, AcoefQ_0, BcoefH_0, BcoefQ_0,  &
+                            AcoefH, AcoefQ, BcoefH, BcoefQ,  &
+                            HTphiT_b, dd_HTphiT, HTphiQ_b, dd_HTphiQ, HTRn_b, dd_HTRn, &
+                            phiT0_b, dphiT0, phiQ0_b, dphiQ0, Rn0_b, dRn0, &
+                            yg_T, yg_Q, &
+                            yGamma_dTs_phiT, yGamma_dQs_phiQ, &
+                            ydTs_ins, ydqs_ins &
+                            )
+          ELSE !
+            AcoefH(:) = AcoefH_0(:)
+            AcoefQ(:) = AcoefQ_0(:)
+            BcoefH(:) = BcoefH_0(:)
+            BcoefQ(:) = BcoefQ_0(:)
+            yg_T(:) = 0.
+            yg_Q(:) = 0.
+            yGamma_dTs_phiT(:) = 0.
+            yGamma_dQs_phiQ(:) = 0.
+            ydTs_ins(:) = 0.
+            ydqs_ins(:) = 0.
+          ENDIF   ! (iflag_split .eq. 2)
+!
+        ELSE    ! (nsrf .ne. is_oce)
+          ybeta(1:knon) = 1.
+          yevap_pot(1:knon) = yevap(1:knon)
+          AcoefH(:) = AcoefH_0(:)
+          AcoefQ(:) = AcoefQ_0(:)
+          BcoefH(:) = BcoefH_0(:)
+          BcoefQ(:) = BcoefQ_0(:)
+          yg_T(:) = 0.
+          yg_Q(:) = 0.
+          yGamma_dTs_phiT(:) = 0.
+          yGamma_dQs_phiQ(:) = 0.
+          ydTs_ins(:) = 0.
+          ydqs_ins(:) = 0.
+        ENDIF   ! (nsrf .ne. is_oce)
+! 
+        CALL wx_pbl_split(knon, nsrf, dtime, ywake_s, ybeta, iflag_split, &
+                       yg_T, yg_Q, &
+                       yGamma_dTs_phiT, yGamma_dQs_phiQ, &
+                       ydTs_ins, ydqs_ins, &
                        y_flux_t1, y_flux_q1, y_flux_u1, y_flux_v1, &
+!!!!                       HTRn_b, dd_HTRn, HTphiT_b, dd_HTphiT, &
+                       phiQ0_b, phiT0_b, &
                        y_flux_t1_x, y_flux_t1_w, &
                        y_flux_q1_x, y_flux_q1_w, &
@@ -2465,7 +2705,49 @@
                        y_flux_v1_x, y_flux_v1_w, &
                        yfluxlat_x, yfluxlat_w, &
-                       y_delta_tsurf &
+                       y_delta_qsats, &
+                       y_delta_tsurf_new, y_delta_qsurf &
                        )
+!
+         CALL wx_pbl_check(knon, dtime, ypplay, ypaprs, ywake_s, ybeta, iflag_split, &
+                       yTs, y_delta_tsurf,  & 
+                       yqsurf, yTsurf_new,  &
+                       y_delta_tsurf_new, y_delta_qsats,  &
+                       AcoefH_x, AcoefH_w, &
+                       BcoefH_x, BcoefH_w, &
+                       AcoefH_0, AcoefQ_0, BcoefH_0, BcoefQ_0,  &
+                       AcoefH, AcoefQ, BcoefH, BcoefQ,  &
+                       y_flux_t1, y_flux_q1,  &
+                       y_flux_t1_x, y_flux_t1_w, &
+                       y_flux_q1_x, y_flux_q1_w)
+!
+         IF (nsrf .ne. is_oce) THEN
+           CALL wx_pbl_dts_check(knon, dtime, ypplay, ypaprs, ywake_s, ybeta, iflag_split, &
+                         yTs, y_delta_tsurf,  & 
+                         yqsurf, yTsurf_new,  &
+                         y_delta_qsats, y_delta_tsurf_new, y_delta_qsurf,  &
+                         AcoefH_x, AcoefH_w, &
+                         BcoefH_x, BcoefH_w, &
+                         AcoefH_0, AcoefQ_0, BcoefH_0, BcoefQ_0,  &
+                         AcoefH, AcoefQ, BcoefH, BcoefQ,  &
+                         HTphiT_b, dd_HTphiT, HTphiQ_b, dd_HTphiQ, HTRn_b, dd_HTRn, &
+                         phiT0_b, dphiT0, phiQ0_b, dphiQ0, Rn0_b, dRn0, &
+                         yg_T, yg_Q, &
+                         yGamma_dTs_phiT, yGamma_dQs_phiQ, &
+                         ydTs_ins, ydqs_ins, &
+                         y_flux_t1, y_flux_q1,  &
+                         y_flux_t1_x, y_flux_t1_w, &
+                         y_flux_q1_x, y_flux_q1_w )
+         ENDIF   ! (nsrf .ne. is_oce)
+!
+       ELSE  ! (iflag_split .ge. 1)
+         ybeta(1:knon) = 1.
+         yevap_pot(1:knon) = yevap(1:knon)
        ENDIF  ! (iflag_split .ge. 1)
+!
+       IF (prt_level >= 10) THEN
+         print *,'pbl_surface, ybeta , yevap, yevap_pot ', &
+                               ybeta , yevap, yevap_pot
+       ENDIF  ! (prt_level >= 10)
+!
 !>jyg
 !
@@ -2648,10 +2930,10 @@
        ENDIF  ! (iflag_split .eq.0)
 !!!
-
-        DO j = 1, knon
-          y_dflux_t(j) = y_dflux_t(j) * ypct(j)
-          y_dflux_q(j) = y_dflux_q(j) * ypct(j)
-        ENDDO
-
+!!
+!!        DO j = 1, knon
+!!          y_dflux_t(j) = y_dflux_t(j) * ypct(j)
+!!          y_dflux_q(j) = y_dflux_q(j) * ypct(j)
+!!        ENDDO
+!!
 !****************************************************************************************
 ! 13) Transform variables for output format : 
@@ -2821,4 +3103,5 @@
           i = ni(j)
           evap(i,nsrf) = - flux_q(i,1,nsrf)                  !jyg
+          beta(i,nsrf) = ybeta(j)                             !jyg
           d_ts(i,nsrf) = y_d_ts(j)
 !albedo SB >>>
@@ -2836,6 +3119,6 @@
           cdragh(i) = cdragh(i) + ycdragh(j)*ypct(j)
           cdragm(i) = cdragm(i) + ycdragm(j)*ypct(j)
-          dflux_t(i) = dflux_t(i) + y_dflux_t(j)
-          dflux_q(i) = dflux_q(i) + y_dflux_q(j)
+          dflux_t(i) = dflux_t(i) + y_dflux_t(j)*ypct(j)
+          dflux_q(i) = dflux_q(i) + y_dflux_q(j)*ypct(j)
 #ifdef ISO
         do ixt=1,niso
@@ -2844,5 +3127,5 @@
         do ixt=1,ntraciso
           xtevap(ixt,i,nsrf) = - flux_xt(ixt,i,1,nsrf)
-          dflux_xt(ixt,i) = dflux_xt(ixt,i) + y_dflux_xt(ixt,j) 
+          dflux_xt(ixt,i) = dflux_xt(ixt,i) + y_dflux_xt(ixt,j)*ypct(j)
         enddo  
         IF (nsrf == is_lic) THEN
@@ -2874,5 +3157,8 @@
 !!! nrlmd le 13/06/2011
 !!jyg20170131          delta_tsurf(i,nsrf)=y_delta_tsurf(j)*ypct(j)
-          delta_tsurf(i,nsrf)=y_delta_tsurf(j)
+!!jyg20210118          delta_tsurf(i,nsrf)=y_delta_tsurf(j)
+          delta_tsurf(i,nsrf)=y_delta_tsurf_new(j)
+!
+          delta_qsurf(i) = delta_qsurf(i) + y_delta_qsurf(j)*ypct(j)
 !
           cdragh_x(i) = cdragh_x(i) + ycdragh_x(j)*ypct(j)
@@ -2918,4 +3204,5 @@
               tke_x(i,k,nsrf)    = ytke(j,k)
               tke_x(i,k,is_ave) = tke_x(i,k,is_ave) + ytke(j,k)*ypct(j)
+
 !>jyg
            ENDDO
@@ -2931,6 +3218,7 @@
 !!            tke(i,k,is_ave) = tke(i,k,is_ave) + tke(i,k,nsrf)*ypct(j)
             tke_x(i,k,nsrf)   = ytke_x(j,k)
-            tke_x(i,k,is_ave)   = tke_x(i,k,is_ave) + tke_x(i,k,nsrf)*ypct(j)
+            tke_x(i,k,is_ave)   = tke_x(i,k,is_ave) + tke_x(i,k,nsrf)*ypct(j)        
             wake_dltke(i,k,is_ave)   = wake_dltke(i,k,is_ave) + wake_dltke(i,k,nsrf)*ypct(j)
+            
 
 !>jyg
@@ -3069,4 +3357,30 @@
           d_t_w(:,1), d_t_x(:,1), d_t(:,1)
        ENDIF
+
+       if (nsrf == is_oce .and. activate_ocean_skin >= 1) then
+          delta_sal = missing_val
+          ds_ns = missing_val
+          dt_ns = missing_val
+          delta_sst = missing_val
+          dter = missing_val
+          dser = missing_val
+          tkt = missing_val
+          tks = missing_val
+          taur = missing_val
+          sss = missing_val
+          
+          delta_sal(ni(:knon)) = ydelta_sal(:knon)
+          ds_ns(ni(:knon)) = yds_ns(:knon)
+          dt_ns(ni(:knon)) = ydt_ns(:knon)
+          delta_sst(ni(:knon)) = ydelta_sst(:knon)
+          dter(ni(:knon)) = ydter(:knon)
+          dser(ni(:knon)) = ydser(:knon)
+          tkt(ni(:knon)) = ytkt(:knon)
+          tks(ni(:knon)) = ytks(:knon)
+          taur(ni(:knon)) = ytaur(:knon)
+          sss(ni(:knon)) = ysss(:knon)
+       end if
+
+
 
 !****************************************************************************************
@@ -3106,5 +3420,6 @@
                * (ypaprs(j,1)-ypplay(j,1))
           tairsol(j) = yts(j) + y_d_ts(j)
-          tairsol_x(j) = tairsol(j) - ywake_s(j)*y_delta_tsurf(j)
+!!          tairsol_x(j) = tairsol(j) - ywake_s(j)*y_delta_tsurf(j)
+          tairsol_x(j) = tairsol(j) - ywake_s(j)*y_delta_tsurf_new(j)
           qairsol(j) = yqsurf(j)
         ENDDO
@@ -3145,9 +3460,29 @@
 !!! jyg le 07/02/2012
        IF (iflag_split .eq.0) THEN
+        IF (iflag_new_t2mq2m==1) THEN
+         CALL stdlevvarn(klon, knon, nsrf, zxli, &
+            uzon, vmer, tair1, qair1, zgeo1, &
+            tairsol, qairsol, yz0m, yz0h_oupas, psfce, patm, &
+            yt2m, yq2m, yt10m, yq10m, yu10m, yustar, &
+            yn2mout(:, nsrf, :))
+        ELSE
         CALL stdlevvar(klon, knon, nsrf, zxli, &
             uzon, vmer, tair1, qair1, zgeo1, &
             tairsol, qairsol, yz0m, yz0h_oupas, psfce, patm, &
             yt2m, yq2m, yt10m, yq10m, yu10m, yustar)
+        ENDIF
        ELSE  !(iflag_split .eq.0)
+        IF (iflag_new_t2mq2m==1) THEN
+         CALL stdlevvarn(klon, knon, nsrf, zxli, &
+            uzon_x, vmer_x, tair1_x, qair1_x, zgeo1_x, &
+            tairsol_x, qairsol, yz0m, yz0h_oupas, psfce, patm, &
+            yt2m_x, yq2m_x, yt10m_x, yq10m_x, yu10m_x, yustar_x, &
+            yn2mout_x(:, nsrf, :))
+         CALL stdlevvarn(klon, knon, nsrf, zxli, &
+            uzon_w, vmer_w, tair1_w, qair1_w, zgeo1_w, &
+            tairsol_w, qairsol, yz0m, yz0h_oupas, psfce, patm, &
+            yt2m_w, yq2m_w, yt10m_w, yq10m_w, yu10m_w, yustar_w, &
+            yn2mout_w(:, nsrf, :))
+        ELSE
         CALL stdlevvar(klon, knon, nsrf, zxli, &
             uzon_x, vmer_x, tair1_x, qair1_x, zgeo1_x, &
@@ -3158,4 +3493,5 @@
             tairsol_w, qairsol, yz0m, yz0h_oupas, psfce, patm, &
             yt2m_w, yq2m_w, yt10m_w, yq10m_w, yu10m_w, yustar_w)
+        ENDIF
 !!!
        ENDIF  ! (iflag_split .eq.0)
@@ -3171,4 +3507,9 @@
           u10m(i,nsrf)=(yu10m(j) * uzon(j))/SQRT(uzon(j)**2+vmer(j)**2)
           v10m(i,nsrf)=(yu10m(j) * vmer(j))/SQRT(uzon(j)**2+vmer(j)**2)
+!
+          DO k = 1, 6
+           n2mout(i,nsrf,k) = yn2mout(j,nsrf,k)
+          END DO  
+!
         ENDDO
        ELSE  !(iflag_split .eq.0)
@@ -3181,4 +3522,9 @@
           u10m_x(i,nsrf)=(yu10m_x(j) * uzon_x(j))/SQRT(uzon_x(j)**2+vmer_x(j)**2)
           v10m_x(i,nsrf)=(yu10m_x(j) * vmer_x(j))/SQRT(uzon_x(j)**2+vmer_x(j)**2)
+!
+          DO k = 1, 6
+           n2mout_x(i,nsrf,k) = yn2mout_x(j,nsrf,k)
+          END DO  
+!
         ENDDO
         DO j=1, knon
@@ -3194,4 +3540,9 @@
           u10m(i,nsrf) = u10m_x(i,nsrf) + wake_s(i)*(u10m_w(i,nsrf)-u10m_x(i,nsrf))
           v10m(i,nsrf) = v10m_x(i,nsrf) + wake_s(i)*(v10m_w(i,nsrf)-v10m_x(i,nsrf))
+!
+          DO k = 1, 6
+           n2mout_w(i,nsrf,k) = yn2mout_w(j,nsrf,k)
+          END DO  
+!
         ENDDO
 !!!
@@ -3479,10 +3830,10 @@
 #endif
 !!!
-   
+
 !
 ! Incrementer la temperature du sol
 !
     zxtsol(:) = 0.0  ; zxfluxlat(:) = 0.0
-    zt2m(:) = 0.0    ; zq2m(:) = 0.0 
+    zt2m(:) = 0.0    ; zq2m(:) = 0.0 ; zn2mout(:,:) = 0
     zustar(:)=0.0 ; zu10m(:) = 0.0   ; zv10m(:) = 0.0
     s_pblh(:) = 0.0  ; s_plcl(:) = 0.0 
@@ -3537,4 +3888,9 @@
           zt2m(i)  = zt2m(i)  + t2m(i,nsrf)  * pctsrf(i,nsrf)
           zq2m(i)  = zq2m(i)  + q2m(i,nsrf)  * pctsrf(i,nsrf)
+!
+          DO k = 1, 6
+           zn2mout(i,k)  = zn2mout(i,k)  + n2mout(i,nsrf,k)  * pctsrf(i,nsrf)
+          ENDDO  
+!
           zustar(i) = zustar(i) + ustar(i,nsrf) * pctsrf(i,nsrf)
           wstar(i,is_ave)=wstar(i,is_ave)+wstar(i,nsrf)*pctsrf(i,nsrf)
@@ -3568,4 +3924,9 @@
           zt2m(i)  = zt2m(i)  + (t2m_x(i,nsrf)+wake_s(i)*(t2m_w(i,nsrf)-t2m_x(i,nsrf))) * pctsrf(i,nsrf)
           zq2m(i)  = zq2m(i)  + q2m_x(i,nsrf)  * pctsrf(i,nsrf)
+!
+          DO k = 1, 6
+           zn2mout(i,k)  = zn2mout(i,k)  + n2mout_x(i,nsrf,k)  * pctsrf(i,nsrf)
+          ENDDO
+!
           zustar(i) = zustar(i) + ustar_x(i,nsrf) * pctsrf(i,nsrf)
           wstar(i,is_ave)=wstar(i,is_ave)+wstar_x(i,nsrf)*pctsrf(i,nsrf)
@@ -3649,5 +4010,5 @@
     DO nsrf = 1, nbsrf
        DO i = 1, klon
-          zxqsurf(i) = zxqsurf(i) + qsurf(i,nsrf) * pctsrf(i,nsrf)
+          zxqsurf(i) = zxqsurf(i) + MAX(qsurf(i,nsrf),0.0) * pctsrf(i,nsrf)
           zxsnow(i)  = zxsnow(i)  + snow(i,nsrf)  * pctsrf(i,nsrf)
 #ifdef ISO
@@ -3718,4 +4079,6 @@
     IF (ALLOCATED(qsurf)) DEALLOCATE(qsurf)
     IF (ALLOCATED(ftsoil)) DEALLOCATE(ftsoil)
+    IF (ALLOCATED(ydTs0)) DEALLOCATE(ydTs0)
+    IF (ALLOCATED(ydqs0)) DEALLOCATE(ydqs0)
 #ifdef ISO
     IF (ALLOCATED(xtsnow)) DEALLOCATE(xtsnow)
@@ -3739,7 +4102,7 @@
 
 !albedo SB >>>
-SUBROUTINE pbl_surface_newfrac(itime, pctsrf_new, pctsrf_old, &
-     evap, z0m, z0h, agesno,                                  &
-     tsurf,alb_dir,alb_dif, ustar, u10m, v10m, tke &
+  SUBROUTINE pbl_surface_newfrac(itime, pctsrf_new, pctsrf_old, &
+       evap, z0m, z0h, agesno,                                  &
+       tsurf,alb_dir,alb_dif, ustar, u10m, v10m, tke &
 #ifdef ISO
      ,xtevap  &
@@ -3750,4 +4113,6 @@
 
     USE indice_sol_mod
+    use phys_state_var_mod, only: delta_sal, ds_ns, dt_ns, delta_sst
+    use config_ocean_skin_m, only: activate_ocean_skin
 #ifdef ISO
   USE infotrac_phy, ONLY: ntraciso    
@@ -3852,4 +4217,14 @@
                       alb_dif(i,k,nsrf) = 0.06
                    ENDDO
+                   if (activate_ocean_skin >= 1) then
+                      if (activate_ocean_skin == 2 &
+                           .and. type_ocean == "couple") then
+                         delta_sal(i) = 0.
+                         delta_sst(i) = 0.
+                      end if
+                      
+                      ds_ns(i) = 0.
+                      dt_ns(i) = 0.
+                   end if
                 ELSE IF (nsrf.EQ.is_sic) THEN
                    tsurf(i,nsrf) = 271.35
Index: LMDZ6/trunk/libf/phylmdiso/perturb_radlwsw.F90
===================================================================
--- LMDZ6/trunk/libf/phylmdiso/perturb_radlwsw.F90	(revision 3939)
+++ LMDZ6/trunk/libf/phylmdiso/perturb_radlwsw.F90	(revision 3940)
@@ -1,27 +1,1 @@
-      SUBROUTINE perturb_radlwsw(zxtsol,iflag_radia)
-!
-!Case-specific radiative setup
-!
-      use dimphy
-      IMPLICIT none
-      INCLUDE "flux_arp.h"     
-!
-! Arguments :
-!------------
-      REAL,DIMENSION(klon), INTENT(INOUT) :: zxtsol
-      INTEGER, INTENT(IN)                 :: iflag_radia
-!
-!======================================================================
-!
-      IF (iflag_radia == 2) THEN
-!
-! Iflag_radia = 2 : DICE case : 
-!               on force zxtsol=tg pour le rayonnement (MPL 20130806)
-!Sonia : Cas dice lmdz1d force en flux : on impose Tg pour imposer le LWUP
-!
-        zxtsol(:) =  tg
-      ENDIF
-!
-      RETURN
-      END
-
+link ../phylmd/perturb_radlwsw.F90
Index: LMDZ6/trunk/libf/phylmdiso/phyetat0.F90
===================================================================
--- LMDZ6/trunk/libf/phylmdiso/phyetat0.F90	(revision 3939)
+++ LMDZ6/trunk/libf/phylmdiso/phyetat0.F90	(revision 3940)
@@ -1,3 +1,3 @@
-! $Id: phyetat0.F90 3581 2019-10-10 12:35:59Z oboucher $
+! $Id: phyetat0.F90 3890 2021-05-05 15:15:06Z jyg $
 
 SUBROUTINE phyetat0 (fichnom, clesphy0, tabcntr0)
@@ -19,6 +19,6 @@
        ftsol, pbl_tke, pctsrf, q_ancien, ql_ancien, qs_ancien, radpas, radsol, rain_fall, ratqs, &
        rnebcon, rugoro, sig1, snow_fall, solaire_etat0, sollw, sollwdown, &
-       solsw, t_ancien, u_ancien, v_ancien, w01, wake_cstar, wake_deltaq, &
-       wake_deltat, wake_delta_pbl_TKE, delta_tsurf, wake_fip, wake_pe, &
+       solsw, solswfdiff, t_ancien, u_ancien, v_ancien, w01, wake_cstar, wake_deltaq, &
+       wake_deltat, wake_delta_pbl_TKE, delta_tsurf, beta_aridity, wake_fip, wake_pe, &
        wake_s, wake_dens, zgam, zmax0, zmea, zpic, zsig, &
 #ifdef ISO
@@ -27,5 +27,5 @@
 #endif
        zstd, zthe, zval, ale_bl, ale_bl_trig, alp_bl, u10m, v10m, treedrg, &
-       ale_wake, ale_bl_stat
+       ale_wake, ale_bl_stat, ds_ns, dt_ns, delta_sst, delta_sal, ratqs_inter
 !FC
   USE geometry_mod, ONLY : longitude_deg, latitude_deg
@@ -38,4 +38,10 @@
   USE ocean_slab_mod, ONLY: nslay, tslab, seaice, tice, ocean_slab_init
   USE time_phylmdz_mod, ONLY: init_iteration, pdtphys, itau_phy
+#ifdef CPP_XIOS
+  USE wxios, ONLY: missing_val
+#else
+  use netcdf, only: missing_val => nf90_fill_real
+#endif
+  use config_ocean_skin_m, only: activate_ocean_skin
 #ifdef ISO
   USE infotrac_phy, ONLY: ntraciso,niso,iso_num
@@ -52,5 +58,4 @@
   ! Objet: Lecture de l'etat initial pour la physique
   !======================================================================
-  include "netcdf.inc"
   include "dimsoil.h"
   include "clesphys.h"
@@ -330,11 +335,12 @@
 
   found=phyetat0_get(1,solsw,"solsw","net SW radiation surf",0.)
+  found=phyetat0_get(1,solswfdiff,"solswfdiff","fraction of SW radiation surf that is diffuse",1.)
   found=phyetat0_get(1,sollw,"sollw","net LW radiation surf",0.)
   found=phyetat0_get(1,sollwdown,"sollwdown","down LW radiation surf",0.)
   IF (.NOT. found) THEN
-     sollwdown = 0. ;  zts=0.
-     do nsrf=1,nbsrf
+     sollwdown(:) = 0. ;  zts(:)=0.
+     DO nsrf=1,nbsrf
         zts(:)=zts(:)+ftsol(:,nsrf)*pctsrf(:,nsrf)
-     enddo
+     ENDDO
      sollwdown(:)=sollw(:)+RSIGMA*zts(:)**4
   ENDIF
@@ -413,5 +419,8 @@
   IF (iflag_pbl>1 .AND. iflag_wake>=1  .AND. iflag_pbl_split >=1 ) then
     found=phyetat0_srf(klev+1,wake_delta_pbl_tke,"DELTATKE","Del TKE wk/env",0.)
-    found=phyetat0_srf(1,delta_tsurf,"DELTA_TSURF","Delta Ts wk/env ",0.)
+!!    found=phyetat0_srf(1,delta_tsurf,"DELTA_TSURF","Delta Ts wk/env ",0.)
+    found=phyetat0_srf(1,delta_tsurf,"DELTATS","Delta Ts wk/env ",0.)
+!!    found=phyetat0_srf(1,beta_aridity,"BETA_S","Aridity factor ",1.)
+    found=phyetat0_srf(1,beta_aridity,"BETAS","Aridity factor ",1.)
   ENDIF   !(iflag_pbl>1 .AND. iflag_wake>=1 .AND. iflag_pbl_split >=1 )
 
@@ -452,4 +461,8 @@
   found=phyetat0_get(1,ale_bl_stat,"ALE_BL_STAT","ALE_BL_STAT",0.)
 
+! fisrtilp/Clouds 0.002 could be ratqsbas. But can stay like this as well
+  found=phyetat0_get(klev,ratqs_inter,"RATQS_INTER","Relative width of the lsc sugrid scale water",0.002)
+
+
 !===========================================
   ! Read and send field trs to traclmdz
@@ -468,6 +481,6 @@
   ENDIF
 
-!--OB now this is for co2i
-  IF (type_trac == 'co2i') THEN
+!--OB now this is for co2i - ThL: and therefore also for inco
+  IF (type_trac == 'co2i' .OR. type_trac == 'inco') THEN
      IF (carbon_cycle_cpl) THEN
         ALLOCATE(co2_send(klon), stat=ierr)
@@ -564,4 +577,25 @@
   ENDIF ! Slab        
 
+  if (activate_ocean_skin >= 1) then
+     if (activate_ocean_skin == 2 .and. type_ocean == 'couple') then
+        found = phyetat0_get(1, delta_sal, "delta_sal", &
+             "ocean-air interface salinity minus bulk salinity", 0.)
+        found = phyetat0_get(1, delta_sst, "delta_SST", &
+             "ocean-air interface temperature minus bulk SST", 0.)
+     end if
+     
+     found = phyetat0_get(1, ds_ns, "dS_ns", "delta salinity near surface", 0.)
+     found = phyetat0_get(1, dt_ns, "dT_ns", "delta temperature near surface", &
+          0.)
+
+     where (pctsrf(:, is_oce) == 0.)
+        ds_ns = missing_val
+        dt_ns = missing_val
+        delta_sst = missing_val
+        delta_sal = missing_val
+     end where
+  end if
+ 
+
   ! on ferme le fichier
   CALL close_startphy
Index: LMDZ6/trunk/libf/phylmdiso/phyredem.F90
===================================================================
--- LMDZ6/trunk/libf/phylmdiso/phyredem.F90	(revision 3939)
+++ LMDZ6/trunk/libf/phylmdiso/phyredem.F90	(revision 3940)
@@ -12,5 +12,6 @@
   USE fonte_neige_mod,  ONLY : fonte_neige_final
   USE pbl_surface_mod,  ONLY : pbl_surface_final
-  USE phys_state_var_mod, ONLY: radpas, zmasq, pctsrf, ftsol, falb_dir,      &
+  USE phys_state_var_mod, ONLY: radpas, zmasq, pctsrf,                       &
+                                ftsol, beta_aridity, delta_tsurf, falb_dir,  &
                                 falb_dif, qsol, fevap, radsol, solsw, sollw, &
                                 sollwdown, rain_fall, snow_fall, z0m, z0h,   &
@@ -26,6 +27,7 @@
                                 detr_therm, ale_bl, ale_bl_trig, alp_bl,     &
                                 ale_wake, ale_bl_stat,                       &
-                                du_gwd_rando, du_gwd_front, u10m, v10m,      &
-                                treedrg
+                                du_gwd_rando, du_gwd_front, u10m, v10m, &
+                                treedrg, solswfdiff, delta_sal, ds_ns, dt_ns, &
+                                delta_sst, ratqs_inter
 #ifdef ISO
   USE phys_state_var_mod, ONLY: xtsol, fxtevap,xtrain_fall, xtsnow_fall,     &
@@ -48,4 +50,5 @@
   USE ocean_slab_mod, ONLY : nslay, tslab, seaice, tice, fsic
   USE time_phylmdz_mod, ONLY: annee_ref, day_end, itau_phy, pdtphys
+  use config_ocean_skin_m, only: activate_ocean_skin  
 
   IMPLICIT none
@@ -179,5 +182,13 @@
     END IF
 
+!    Surface variables 
     CALL put_field_srf1(pass,"TS","Temperature",ftsol(:,:))
+
+!!    CALL put_field_srf1(pass,"DELTA_TS","w-x surface temperature difference", delta_tsurf(:,:))
+    CALL put_field_srf1(pass,"DELTATS","w-x surface temperature difference", delta_tsurf(:,:))
+
+!    CALL put_field_srf1(pass,"BETA_S","Aridity factor", beta_aridity(:,:))
+    CALL put_field_srf1(pass,"BETAS","Aridity factor", beta_aridity(:,:))
+!    End surface variables
 
 ! ================== Albedo =======================================
@@ -209,4 +220,6 @@
 
     CALL put_field(pass,"solsw", "Rayonnement solaire a la surface", solsw)
+
+    CALL put_field(pass,"solswfdiff", "Fraction du rayonnement solaire a la surface qui est diffus", solswfdiff)
 
     CALL put_field(pass,"sollw", "Rayonnement IF a la surface", sollw)
@@ -323,4 +336,8 @@
 
     CALL put_field(pass,"ALE_BL_STAT", "ALE_BL_STAT", ale_bl_stat)
+
+
+    ! fisrtilp/clouds
+    CALL put_field(pass,"RATQS_INTER","Relative width of the lsc sugrid scale water",ratqs_inter)
 
 
@@ -366,4 +383,16 @@
     IF (.not. ok_hines .and. ok_gwd_rando) call put_field(pass,"du_gwd_front", &
          "tendency on zonal wind due to acama gravity waves", du_gwd_front)
+
+    if (activate_ocean_skin >= 1) then
+       if (activate_ocean_skin == 2 .and. type_ocean == 'couple') then
+          CALL put_field(pass, "delta_sal", &
+               "ocean-air interface salinity minus bulk salinity", delta_sal)
+          CALL put_field(pass, "delta_SST", &
+               "ocean-air interface temperature minus bulk SST", delta_sst)
+       end if
+       
+       CALL put_field(pass, "dS_ns", "delta salinity near surface", ds_ns)
+       CALL put_field(pass, "dT_ns", "delta temperature near surface", dT_ns)
+    end if
 
 #ifdef ISO
